/**********************************************/
/* OLION80 ϊvO                     */
/*             PC-8001 -> PC-6001mk2SR/6601SR */
/**********************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	S_LEN	255
#define	BUFNUM	16000

#define	IPL1NAME	"ipl1.bin"
#define	IPL2NAME	"ipl2_"
#define	PROGNAME	"olion80_prog_p6_"
#define	ORGNAME		"olion80_org_"
#define	DATA1NAME	"data1.bin"
#define	DATA2NAME	"data2.bin"
#define	DATA3NAME	"data3.bin"
#define	DATA4NAME	"data4.bin"
#define	DATA5NAME	"data5.bin"
#define	DATA6NAME	"data6.bin"
#define	DATA7NAME	"data7.bin"
#define	DATA8NAME	"data8.bin"
#define	DATA9NAME	"data9.bin"
#define	D88NAME		"olion8p6.d88"

int main(int argc, char **argv)
{
	FILE	*ipl1_fp;
	FILE	*ipl2_fp;
	FILE	*prog_fp;
	FILE	*org_fp;
	FILE	*data1_fp;
	FILE	*data2_fp;
	FILE	*data3_fp;
	FILE	*data4_fp;
	FILE	*data5_fp;
	FILE	*data6_fp;
	FILE	*data7_fp;
	FILE	*data8_fp;
	FILE	*data9_fp;
	FILE	*out_fp;
	int		i,j,k,m,z;
	int		b0,b1,b2,b3,b4,b5,b6,b7;
	int		ds,trackpt;
	int		offset;
	int		ccolor;
	int		ccolor_h,ccolor_l;

	char	ipl2[S_LEN],prog[S_LEN],org[S_LEN];

	char	hi_org[90];
	char	men_org[0x0e00];
	char	hiscore[90];


	if (argc != 3) {
		fprintf(stderr, "Usage: gen_dragonp6 v1|v2 offset\n");
		exit(1);
	}

/* offset */
	strncpy(ipl2,IPL2NAME,200);
	strcat(ipl2,argv[1]);
	strcat(ipl2,".bin");
	strncpy(prog,PROGNAME,200);
	strcat(prog,argv[1]);
	strcat(prog,".bin");
	strncpy(org,ORGNAME,200);
	strcat(org,argv[1]);
	strcat(org,".bin");

	offset = atoi(argv[2]);

/* file open */
	if ((ipl1_fp = fopen(IPL1NAME, "rb")) == NULL) {
		perror(IPL1NAME);
		exit(1);
	}

	if ((ipl2_fp = fopen(ipl2, "rb")) == NULL) {
		perror(ipl2);
		exit(1);
	}

	if ((prog_fp = fopen(prog, "rb")) == NULL) {
		perror(prog);
		exit(1);
	}

	if ((org_fp = fopen(org, "rb")) == NULL) {
		perror(org);
		exit(1);
	}

	if ((data1_fp = fopen(DATA1NAME, "rb")) == NULL) {
		perror(DATA1NAME);
		exit(1);
	}

	if ((data2_fp = fopen(DATA2NAME, "rb")) == NULL) {
		perror(DATA2NAME);
		exit(1);
	}

	if ((data3_fp = fopen(DATA3NAME, "rb")) == NULL) {
		perror(DATA3NAME);
		exit(1);
	}

	if ((data4_fp = fopen(DATA4NAME, "rb")) == NULL) {
		perror(DATA4NAME);
		exit(1);
	}

	if ((data5_fp = fopen(DATA5NAME, "rb")) == NULL) {
		perror(DATA5NAME);
		exit(1);
	}

	if ((data6_fp = fopen(DATA6NAME, "rb")) == NULL) {
		perror(DATA6NAME);
		exit(1);
	}

	if ((data7_fp = fopen(DATA7NAME, "rb")) == NULL) {
		perror(DATA7NAME);
		exit(1);
	}

	if ((data8_fp = fopen(DATA8NAME, "rb")) == NULL) {
		perror(DATA8NAME);
		exit(1);
	}

	if ((data9_fp = fopen(DATA9NAME, "rb")) == NULL) {
		perror(DATA9NAME);
		exit(1);
	}

	if ((out_fp = fopen(D88NAME, "wb")) == NULL) {
		perror(D88NAME);
		exit(1);
	}


	for (i = 0;i < 90;i ++) {
		hiscore[i] = 0;
	}

	hiscore[0] = 0;
	hiscore[1] = 0x66;
	hiscore[2] = 0;
	hiscore[3] = 0x60;
	hiscore[4] = 0;
	hiscore[5] = 0x30;
	hiscore[6] = 0;
	hiscore[7] = 0x20;
	hiscore[8] = 0;
	hiscore[9] = 0x10;

	strncpy(&hiscore[10+16*0],"PC-6601SR",9);
	strncpy(&hiscore[10+16*1],"P6mk2SR  ",9);
	strncpy(&hiscore[10+16*2],"PC-6601  ",9);
	strncpy(&hiscore[10+16*3],"PC6001mk2",9);
	strncpy(&hiscore[10+16*4],"PC-6001  ",9);



/* header */

	fputs("OLION8p6",out_fp);
	for (i=0; i<19; i ++) {
		fputc(0,out_fp);
	}

/* disk type (2DD=0x10) */
	fputc(0x10,out_fp);

/* disk size (4 bytes) */

/* header 0x2b0 */
/* track#0x00-0x4F (0x10+0x100) * 0x10 */

	ds = 0x2b0 + 0x10 * 0x110 * 80;

	fputc(  (ds & 0x000000ff)      ,out_fp);
	fputc( ((ds & 0x0000ff00)>> 8) ,out_fp);
	fputc( ((ds & 0x00ff0000)>>16) ,out_fp);
	fputc( ((ds & 0xff000000)>>24) ,out_fp);

/* track data table (164 * 4 bytes) */

	trackpt = 0x2b0;

	for (i=0; i<160; i+=2) {
		fputc(  (trackpt & 0x000000ff)      ,out_fp);	// even track (head=0)
		fputc( ((trackpt & 0x0000ff00)>> 8) ,out_fp);
		fputc( ((trackpt & 0x00ff0000)>>16) ,out_fp);
		fputc( ((trackpt & 0xff000000)>>24) ,out_fp);
		fputc(0,out_fp);								// odd track (head=1)
		fputc(0,out_fp);
		fputc(0,out_fp);
		fputc(0,out_fp);
		trackpt += (0x10 * 0x110);
	}

	for (; i<164; i++) {
		fputc(0,out_fp);
		fputc(0,out_fp);
		fputc(0,out_fp);
		fputc(0,out_fp);
	}

	ccolor = 0x9577 - offset;

	ccolor_h = (ccolor & 0xff00) >> 8;
	ccolor_l = (ccolor & 0x00ff);

	for (k=0; k<80; k ++) {

/* header */
		for (i=0; i<16; i++) {
			fputc(k,out_fp);	// C
			fputc(0,out_fp);	// H
			fputc(i+1,out_fp);	// R
			fputc(1,out_fp);	// N
			fputc(16,out_fp);	// sector number
			fputc(0,out_fp);	// sector number
			fputc(0,out_fp);	// MFM
			fputc(0,out_fp);	// normal data
			fputc(0,out_fp);	// status normal
			fputc(0,out_fp);	// reserved
			fputc(0,out_fp);	// reserved
			fputc(0,out_fp);	// reserved
			fputc(0,out_fp);	// reserved
			fputc(0,out_fp);	// reserved
			fputc(0,out_fp);	// sector size
			fputc(1,out_fp);	// sector size


			switch (k) {
				case  0:

/* track#0 */
					for (j=0; j<256; j++ ) {
						if (i == 0) {
							fputc(fgetc(ipl1_fp),out_fp);	// track#0 sec#1 -> IPL1
						} else if (1 <= i && i < 4) {
							fputc(fgetc(ipl2_fp),out_fp);	// track#0 sec#2,3,4 -> IPL2
						} else {
							fputc(0x00,out_fp);
						}
					}
					break;

/* track#1 -> prog_p6 */

				case  1:
					for (j=0; j<256; j++ ) {
						fputc(fgetc(prog_fp),out_fp);
					}
					break;

				case  2:
				case  3:
				case  4:
				case  5:
				case  6:
				case  7:

/* track#2-7 -> org */
					for (j=0; j<256; j++ ) {
						m = (k-2)*0x1000 + i*0x100 + j + 0x8000;

						if (0x902b <= m && m < 0xc000) {
							m = m + offset;
						}

						if (k == 7 && i >= 12) {
							fputc(0x00,out_fp);
						} else if (
							(0xd000 <= m && m < 0xd600) ||
							(0x8c22 <= m && m < 0x8c4d) ||
							(0x8e34 <= m && m < 0x8e3c) ||
							(m == 0xa39e+6*0+2) ||
							(m == 0xa39e+6*0+3) ||
							(m == 0xa39e+6*1+2) ||
							(m == 0xa39e+6*1+3) ||
							(m == 0xa39e+6*2+2) ||
							(m == 0xa39e+6*2+3) ||
							(m == 0xa39e+6*3+2) ||
							(m == 0xa39e+6*3+3) ||
							(m == 0xa39e+6*4+2) ||
							(m == 0xa39e+6*4+3) ||
							(m == 0xa39e+6*5+2) ||
							(m == 0xa39e+6*5+3) ||
							(m == 0xa39e+6*6+2) ||
							(m == 0xa39e+6*6+3) ||
							(m == 0xa39e+6*7+2) ||
							(m == 0xa39e+6*7+3) ||
							(m == 0xa39e+6*8+2) ||
							(m == 0xa39e+6*8+3) ||
							(m == 0xa39e+6*9+2) ||
							(m == 0xa39e+6*9+3)
						) {
							z = fgetc(org_fp);
							b0 = (z & 0x01);
							b1 = (z & 0x02) >> 1;
							b2 = (z & 0x04) >> 2;
							b3 = (z & 0x08) >> 3;
							b4 = (z & 0x10) >> 4;
							b5 = (z & 0x20) >> 5;
							b6 = (z & 0x40) >> 6;
							b7 = (z & 0x80) >> 7;

							z =
								b0 * 0x80 +
								b4 * 0x40 +
								b1 * 0x20 +
								b5 * 0x10 +
								b2 * 0x08 +
								b6 * 0x04 +
								b3 * 0x02 +
								b7 * 0x01 ;

							fputc(z,out_fp);

						} else {
							switch (m) {

/* ̃vOɃpb`𓖂Ă */

// DEMO
								case 0x82e9+ 0: fputc(0xcd,out_fp); z=fgetc(org_fp); break;
								case 0x82e9+ 1: fputc(0x21,out_fp); z=fgetc(org_fp); break;
								case 0x82e9+ 2: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0x82e9+ 3: fputc(0xd8,out_fp); z=fgetc(org_fp); break;
								case 0x82e9+ 4: fputc(0x3d,out_fp); z=fgetc(org_fp); break;
								case 0x82e9+ 5: fputc(0xc8,out_fp); z=fgetc(org_fp); break;
								case 0x82e9+ 6: fputc(0x3d,out_fp); z=fgetc(org_fp); break;
								case 0x82e9+ 7: fputc(0xcc,out_fp); z=fgetc(org_fp); break;
								case 0x82e9+ 8: fputc(0xa0,out_fp); z=fgetc(org_fp); break;
								case 0x82e9+ 9: fputc(0x83,out_fp); z=fgetc(org_fp); break;
								case 0x82e9+10: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0x82e9+11: fputc(0xff,out_fp); z=fgetc(org_fp); break;
								case 0x82e9+12: fputc(0x82,out_fp); z=fgetc(org_fp); break;

								case 0x834e+ 0: fputc(0xcd,out_fp); z=fgetc(org_fp); break;
								case 0x834e+ 1: fputc(0x21,out_fp); z=fgetc(org_fp); break;
								case 0x834e+ 2: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0x834e+ 3: fputc(0xda,out_fp); z=fgetc(org_fp); break;
								case 0x834e+ 4: fputc(0x82,out_fp); z=fgetc(org_fp); break;
								case 0x834e+ 5: fputc(0x83,out_fp); z=fgetc(org_fp); break;
								case 0x834e+ 6: fputc(0x3d,out_fp); z=fgetc(org_fp); break;
								case 0x834e+ 7: fputc(0xca,out_fp); z=fgetc(org_fp); break;
								case 0x834e+ 8: fputc(0x82,out_fp); z=fgetc(org_fp); break;
								case 0x834e+ 9: fputc(0x83,out_fp); z=fgetc(org_fp); break;
								case 0x834e+10: fputc(0x3d,out_fp); z=fgetc(org_fp); break;
								case 0x834e+11: fputc(0x20,out_fp); z=fgetc(org_fp); break;
								case 0x834e+12: fputc(0x04,out_fp); z=fgetc(org_fp); break;
								case 0x834e+13: fputc(0xe1,out_fp); z=fgetc(org_fp); break;
								case 0x834e+14: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x834e+15: fputc(0x18,out_fp); z=fgetc(org_fp); break;
								case 0x834e+16: fputc(0x41,out_fp); z=fgetc(org_fp); break;

								case 0x8370+0: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0x8370+1: fputc(0x77,out_fp); z=fgetc(org_fp); break;
								case 0x8370+2: fputc(0x83,out_fp); z=fgetc(org_fp); break;

// PAUSE
								case 0x8814+0: fputc(0xcd,out_fp); z=fgetc(org_fp); break;
								case 0x8814+1: fputc(0x1e,out_fp); z=fgetc(org_fp); break;
								case 0x8814+2: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0x8814+3: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x8814+4: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x8814+5: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x8814+6: fputc(0x00,out_fp); z=fgetc(org_fp); break;

								case 0x8a1b+0: fputc(0xcd,out_fp); z=fgetc(org_fp); break;
								case 0x8a1b+1: fputc(0x1e,out_fp); z=fgetc(org_fp); break;
								case 0x8a1b+2: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0x8a1b+3: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x8a1b+4: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x8a1b+5: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x8a1b+6: fputc(0x00,out_fp); z=fgetc(org_fp); break;

								case 0xb0a7+0: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0xb0a7+1: fputc(0x1e,out_fp); z=fgetc(org_fp); break;
								case 0xb0a7+2: fputc(0x70,out_fp); z=fgetc(org_fp); break;

// VSYNC҂
								case 0x8a0b+0: fputc(0xcd,out_fp); z=fgetc(org_fp); break;
								case 0x8a0b+1: fputc(0x1b,out_fp); z=fgetc(org_fp); break;
								case 0x8a0b+2: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0x8a0b+3: fputc(0x18,out_fp); z=fgetc(org_fp); break;
								case 0x8a0b+4: fputc(0x07,out_fp); z=fgetc(org_fp); break;
								case 0xa403+0: fputc(0xcd,out_fp); z=fgetc(org_fp); break;
								case 0xa403+1: fputc(0x1b,out_fp); z=fgetc(org_fp); break;
								case 0xa403+2: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xa403+3: fputc(0x18,out_fp); z=fgetc(org_fp); break;
								case 0xa403+4: fputc(0x07,out_fp); z=fgetc(org_fp); break;
								case 0xa9ec+0: fputc(0xcd,out_fp); z=fgetc(org_fp); break;
								case 0xa9ec+1: fputc(0x1b,out_fp); z=fgetc(org_fp); break;
								case 0xa9ec+2: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xa9ec+3: fputc(0x18,out_fp); z=fgetc(org_fp); break;
								case 0xa9ec+4: fputc(0x07,out_fp); z=fgetc(org_fp); break;

// BEEP֘A
								case 0x85ac+0: fputc(0xd7,out_fp); z=fgetc(org_fp); break;
								case 0x85ac+1: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x85c4+0: fputc(0xd7,out_fp); z=fgetc(org_fp); break;
								case 0x85c4+1: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x87d8+0: fputc(0xd7,out_fp); z=fgetc(org_fp); break;
								case 0x87d8+1: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x8826+0: fputc(0xd7,out_fp); z=fgetc(org_fp); break;
								case 0x8826+1: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x9b0e+0: fputc(0xd7,out_fp); z=fgetc(org_fp); break;
								case 0x9b0e+1: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x9b1e+0: fputc(0xd7,out_fp); z=fgetc(org_fp); break;
								case 0x9b1e+1: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x9b38+0: fputc(0xd7,out_fp); z=fgetc(org_fp); break;
								case 0x9b38+1: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0xa9bc+0: fputc(0xd7,out_fp); z=fgetc(org_fp); break;
								case 0xa9bc+1: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0xaf4e+0: fputc(0xd7,out_fp); z=fgetc(org_fp); break;
								case 0xaf4e+1: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0xaf5e+0: fputc(0xd7,out_fp); z=fgetc(org_fp); break;
								case 0xaf5e+1: fputc(0x00,out_fp); z=fgetc(org_fp); break;

// SPACE͑҂
								case 0x8385+0: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0x8385+1: fputc(0x06,out_fp); z=fgetc(org_fp); break;
								case 0x8385+2: fputc(0x70,out_fp); z=fgetc(org_fp); break;

// Q[Jn

// ʐ؂ւ
								case 0x8a78+0: fputc(0x10,out_fp); z=fgetc(org_fp); break;
								case 0x8a7c+0: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0x8a7c+1: fputc(0x03,out_fp); z=fgetc(org_fp); break;
								case 0x8a7c+2: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0x8a8b+0: fputc(0x20,out_fp); z=fgetc(org_fp); break;

// BOX FILL
								case 0x8adb: fputc(0xa0,out_fp); z=fgetc(org_fp); break;
								case 0x8add: fputc(0x07,out_fp); z=fgetc(org_fp); break;
								case 0x8ae0: fputc(0x5f,out_fp); z=fgetc(org_fp); break;
								case 0x8b15: fputc(0xef,out_fp); z=fgetc(org_fp); break;
								case 0x8b1a: fputc(0xef,out_fp); z=fgetc(org_fp); break;
								case 0x8b84: fputc(0xa0,out_fp); z=fgetc(org_fp); break;
								case 0x8bb8: fputc(0xef,out_fp); z=fgetc(org_fp); break;
								case 0x8bbf: fputc(0xef,out_fp); z=fgetc(org_fp); break;

// VRAMAhXZo
								case 0x8c06+ 0: fputc(0x57,out_fp); z=fgetc(org_fp); break;
								case 0x8c06+ 1: fputc(0x0f,out_fp); z=fgetc(org_fp); break;
								case 0x8c06+ 2: fputc(0x0f,out_fp); z=fgetc(org_fp); break;
								case 0x8c06+ 3: fputc(0x82,out_fp); z=fgetc(org_fp); break;
								case 0x8c06+ 4: fputc(0x6f,out_fp); z=fgetc(org_fp); break;
								case 0x8c06+ 5: fputc(0x26,out_fp); z=fgetc(org_fp); break;
								case 0x8c06+ 6: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x8c06+ 7: fputc(0x29,out_fp); z=fgetc(org_fp); break;
								case 0x8c06+ 8: fputc(0x29,out_fp); z=fgetc(org_fp); break;
								case 0x8c06+ 9: fputc(0x29,out_fp); z=fgetc(org_fp); break;
								case 0x8c06+10: fputc(0x29,out_fp); z=fgetc(org_fp); break;
								case 0x8c06+11: fputc(0x29,out_fp); z=fgetc(org_fp); break;
								case 0x8c06+12: fputc(0x16,out_fp); z=fgetc(org_fp); break;
								case 0x8c06+13: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x8c06+14: fputc(0x7b,out_fp); z=fgetc(org_fp); break;
								case 0x8c06+15: fputc(0xe6,out_fp); z=fgetc(org_fp); break;
								case 0x8c06+16: fputc(0xfe,out_fp); z=fgetc(org_fp); break;
								case 0x8c06+17: fputc(0x5f,out_fp); z=fgetc(org_fp); break;
								case 0x8c06+18: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x8c1c+ 0: fputc(0x20,out_fp); z=fgetc(org_fp); break;

// Agr[g
								case 0x8c70+0: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x8c7e+0: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0x8c7e+1: fputc(0x0f,out_fp); z=fgetc(org_fp); break;
								case 0x8c7e+2: fputc(0x70,out_fp); z=fgetc(org_fp); break;

// ʃNA
								case 0x8dd5: fputc(0xa0,out_fp); z=fgetc(org_fp); break;
								case 0x8dd6: fputc(0x0f,out_fp); z=fgetc(org_fp); break;
								case 0x8ddf: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x8de0: fputc(0x8f,out_fp); z=fgetc(org_fp); break;
								case 0x8de5: fputc(0x48,out_fp); z=fgetc(org_fp); break;
								case 0x8de7: fputc(0x50,out_fp); z=fgetc(org_fp); break;
								case 0x8deb: fputc(0x3e,out_fp); z=fgetc(org_fp); break;
								case 0x8dec: fputc(0x8f,out_fp); z=fgetc(org_fp); break;
								case 0x8ded: fputc(0x32,out_fp); z=fgetc(org_fp); break;
								case 0x8dee: fputc(ccolor_l,out_fp); z=fgetc(org_fp); break;
								case 0x8def: fputc(ccolor_h,out_fp); z=fgetc(org_fp); break;
								case 0x8df0: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x8df1: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x8df2: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x8df3: fputc(0x0d,out_fp); z=fgetc(org_fp); break;

// PSET
								case 0x8e17+ 0: fputc(0x57,out_fp); z=fgetc(org_fp); break;
								case 0x8e17+ 1: fputc(0x0f,out_fp); z=fgetc(org_fp); break;
								case 0x8e17+ 2: fputc(0x0f,out_fp); z=fgetc(org_fp); break;
								case 0x8e17+ 3: fputc(0x82,out_fp); z=fgetc(org_fp); break;
								case 0x8e17+ 4: fputc(0x6f,out_fp); z=fgetc(org_fp); break;
								case 0x8e17+ 5: fputc(0x26,out_fp); z=fgetc(org_fp); break;
								case 0x8e17+ 6: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x8e17+ 7: fputc(0x29,out_fp); z=fgetc(org_fp); break;
								case 0x8e17+ 8: fputc(0x29,out_fp); z=fgetc(org_fp); break;
								case 0x8e17+ 9: fputc(0x29,out_fp); z=fgetc(org_fp); break;
								case 0x8e17+10: fputc(0x29,out_fp); z=fgetc(org_fp); break;
								case 0x8e17+11: fputc(0x29,out_fp); z=fgetc(org_fp); break;
								case 0x8e17+12: fputc(0x16,out_fp); z=fgetc(org_fp); break;
								case 0x8e17+13: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x8e17+14: fputc(0x7b,out_fp); z=fgetc(org_fp); break;
								case 0x8e17+15: fputc(0xe6,out_fp); z=fgetc(org_fp); break;
								case 0x8e17+16: fputc(0xfe,out_fp); z=fgetc(org_fp); break;
								case 0x8e17+17: fputc(0x5f,out_fp); z=fgetc(org_fp); break;
								case 0x8e17+18: fputc(0x00,out_fp); z=fgetc(org_fp); break;

// BOX DELETE
								case 0x8ec3: fputc(0xa0,out_fp); z=fgetc(org_fp); break;
								case 0x8ec5: fputc(0x07,out_fp); z=fgetc(org_fp); break;
								case 0x8ec8: fputc(0x5f,out_fp); z=fgetc(org_fp); break;
								case 0x8efe: fputc(0xef,out_fp); z=fgetc(org_fp); break;
								case 0x8f03: fputc(0xef,out_fp); z=fgetc(org_fp); break;
								case 0x8f6f: fputc(0xa0,out_fp); z=fgetc(org_fp); break;
								case 0x8fa6: fputc(0xef,out_fp); z=fgetc(org_fp); break;
								case 0x8fae: fputc(0xef,out_fp); z=fgetc(org_fp); break;

// G@֘A
								case 0x923f+0: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0x923f+1: fputc(0x30,out_fp); z=fgetc(org_fp); break;
								case 0x923f+2: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0x92c8+0: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0x92c8+1: fputc(0x33,out_fp); z=fgetc(org_fp); break;
								case 0x92c8+2: fputc(0x70,out_fp); z=fgetc(org_fp); break;


// LN^\
								case 0x9388+ 0: fputc(0x7a,out_fp); z=fgetc(org_fp); break;
								case 0x9388+ 1: fputc(0x07,out_fp); z=fgetc(org_fp); break;
								case 0x9388+ 2: fputc(0x07,out_fp); z=fgetc(org_fp); break;
								case 0x9388+ 3: fputc(0x82,out_fp); z=fgetc(org_fp); break;
								case 0x9388+ 4: fputc(0x6f,out_fp); z=fgetc(org_fp); break;
								case 0x9388+ 5: fputc(0xaf,out_fp); z=fgetc(org_fp); break;
								case 0x9388+ 6: fputc(0x67,out_fp); z=fgetc(org_fp); break;
								case 0x9388+ 7: fputc(0x29,out_fp); z=fgetc(org_fp); break;
								case 0x9388+ 8: fputc(0x29,out_fp); z=fgetc(org_fp); break;
								case 0x9388+ 9: fputc(0x29,out_fp); z=fgetc(org_fp); break;
								case 0x9388+10: fputc(0x29,out_fp); z=fgetc(org_fp); break;
								case 0x9388+11: fputc(0x29,out_fp); z=fgetc(org_fp); break;
								case 0x9388+12: fputc(0x57,out_fp); z=fgetc(org_fp); break;
								case 0x9388+13: fputc(0xcb,out_fp); z=fgetc(org_fp); break;
								case 0x9388+14: fputc(0x03,out_fp); z=fgetc(org_fp); break;
								case 0x9388+15: fputc(0x19,out_fp); z=fgetc(org_fp); break;
								case 0x93ae+ 0: fputc(0x00,out_fp); z=fgetc(org_fp); break;

// 4x2LN^\
								case 0x9432+ 0: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0x9432+ 1: fputc(0x09,out_fp); z=fgetc(org_fp); break;
								case 0x9432+ 2: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0x9432+ 3: fputc(0x01,out_fp); z=fgetc(org_fp); break;
								case 0x9432+ 4: fputc(0x02,out_fp); z=fgetc(org_fp); break;
								case 0x9432+ 5: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x9432+ 6: fputc(0xd1,out_fp); z=fgetc(org_fp); break;
								case 0x9432+ 7: fputc(0x7b,out_fp); z=fgetc(org_fp); break;
								case 0x9432+ 8: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x9432+ 9: fputc(0x77,out_fp); z=fgetc(org_fp); break;
								case 0x9432+10: fputc(0x09,out_fp); z=fgetc(org_fp); break;
								case 0x9432+11: fputc(0x7a,out_fp); z=fgetc(org_fp); break;
								case 0x9432+12: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x9432+13: fputc(0x77,out_fp); z=fgetc(org_fp); break;
								case 0x9432+14: fputc(0x09,out_fp); z=fgetc(org_fp); break;
								case 0x9432+15: fputc(0xd1,out_fp); z=fgetc(org_fp); break;
								case 0x9432+16: fputc(0x7b,out_fp); z=fgetc(org_fp); break;
								case 0x9432+17: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x9432+18: fputc(0x77,out_fp); z=fgetc(org_fp); break;
								case 0x9432+19: fputc(0x09,out_fp); z=fgetc(org_fp); break;
								case 0x9432+20: fputc(0x7a,out_fp); z=fgetc(org_fp); break;
								case 0x9432+21: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x9432+22: fputc(0x77,out_fp); z=fgetc(org_fp); break;
								case 0x9432+23: fputc(0x0e,out_fp); z=fgetc(org_fp); break;
								case 0x9432+24: fputc(0x9a,out_fp); z=fgetc(org_fp); break;
								case 0x9432+25: fputc(0x09,out_fp); z=fgetc(org_fp); break;
								case 0x9432+26: fputc(0x3a,out_fp); z=fgetc(org_fp); break;
								case 0x9432+27: fputc(0x73,out_fp); z=fgetc(org_fp); break;
								case 0x9432+28: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0x9432+29: fputc(0x3d,out_fp); z=fgetc(org_fp); break;
								case 0x9432+30: fputc(0x32,out_fp); z=fgetc(org_fp); break;
								case 0x9432+31: fputc(0x73,out_fp); z=fgetc(org_fp); break;
								case 0x9432+32: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0x9432+33: fputc(0x20,out_fp); z=fgetc(org_fp); break;
								case 0x9432+34: fputc(0xe0,out_fp); z=fgetc(org_fp); break;
								case 0x9432+35: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0x9432+36: fputc(0x0c,out_fp); z=fgetc(org_fp); break;
								case 0x9432+37: fputc(0x70,out_fp); z=fgetc(org_fp); break;

// 2x2LN^\
								case 0x946a: fputc(0xe7,out_fp); z=fgetc(org_fp); break;
								case 0x9471: fputc(0x9e,out_fp); z=fgetc(org_fp); break;
								case 0x947b: fputc(0xe7,out_fp); z=fgetc(org_fp); break;

// \[N
								case 0x9575: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x9576: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x9577: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x9578: fputc(0x00,out_fp); z=fgetc(org_fp); break;

// CL[
								case 0x9579+0: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0x9579+1: fputc(0x24,out_fp); z=fgetc(org_fp); break;
								case 0x9579+2: fputc(0x70,out_fp); z=fgetc(org_fp); break;

								case 0x95dd+0: fputc(0x20,out_fp); z=fgetc(org_fp); break;
								case 0x95e7+0: fputc(0x10,out_fp); z=fgetc(org_fp); break;
								case 0x95e7+1: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x95e7+2: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x95e7+3: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x95e7+4: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x95e7+5: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x9624+0: fputc(0x04,out_fp); z=fgetc(org_fp); break;
								case 0x9624+1: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x9624+2: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x9624+3: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x9624+4: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x9624+5: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x9633+0: fputc(0x08,out_fp); z=fgetc(org_fp); break;

// STATUS\
								case 0x98fd: fputc(0x94,out_fp); z=fgetc(org_fp); break;
								case 0x9908: fputc(0x18,out_fp); z=fgetc(org_fp); break;
								case 0x9922: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0x992d: fputc(0x48,out_fp); z=fgetc(org_fp); break;

// l\	
								case 0x99b9: fputc(0xdf,out_fp); z=fgetc(org_fp); break;
								case 0x99ba: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x99bf: fputc(0x9d,out_fp); z=fgetc(org_fp); break;
								case 0x99c3: fputc(0xdf,out_fp); z=fgetc(org_fp); break;
								case 0x99c4: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0x99c8: fputc(0xe7,out_fp); z=fgetc(org_fp); break;
								case 0x99c9: fputc(0xe7,out_fp); z=fgetc(org_fp); break;

// e۔ˏ
								case 0x9a44: fputc(0x7f,out_fp); z=fgetc(org_fp); break;

// Sʔ]
								case 0xa32a+0: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0xa32a+1: fputc(0x36,out_fp); z=fgetc(org_fp); break;
								case 0xa32a+2: fputc(0x70,out_fp); z=fgetc(org_fp); break;

// Ə\
								case 0xa34e+ 0: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0xa34e+ 1: fputc(0x2a,out_fp); z=fgetc(org_fp); break;
								case 0xa34e+ 2: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xa375+ 0: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0xa375+ 1: fputc(0x2d,out_fp); z=fgetc(org_fp); break;
								case 0xa375+ 2: fputc(0x70,out_fp); z=fgetc(org_fp); break;

								case 0xa383+ 0: fputc(0x16,out_fp); z=fgetc(org_fp); break;
								case 0xa383+ 1: fputc(0x09,out_fp); z=fgetc(org_fp); break;

								case 0xa39e+ 0: fputc(0xc8,out_fp); z=fgetc(org_fp); break;
								case 0xa39e+ 1: fputc(0x07,out_fp); z=fgetc(org_fp); break;
								case 0xa39e+ 4: fputc(0xca,out_fp); z=fgetc(org_fp); break;
								case 0xa39e+ 5: fputc(0x07,out_fp); z=fgetc(org_fp); break;
								case 0xa39e+ 6: fputc(0xcc,out_fp); z=fgetc(org_fp); break;
								case 0xa39e+ 7: fputc(0x07,out_fp); z=fgetc(org_fp); break;
								case 0xa39e+10: fputc(0xd4,out_fp); z=fgetc(org_fp); break;
								case 0xa39e+11: fputc(0x07,out_fp); z=fgetc(org_fp); break;
								case 0xa39e+12: fputc(0xd6,out_fp); z=fgetc(org_fp); break;
								case 0xa39e+13: fputc(0x07,out_fp); z=fgetc(org_fp); break;
								case 0xa39e+16: fputc(0xd8,out_fp); z=fgetc(org_fp); break;
								case 0xa39e+17: fputc(0x07,out_fp); z=fgetc(org_fp); break;
								case 0xa39e+18: fputc(0x90,out_fp); z=fgetc(org_fp); break;
								case 0xa39e+19: fputc(0x06,out_fp); z=fgetc(org_fp); break;
								case 0xa39e+22: fputc(0x30,out_fp); z=fgetc(org_fp); break;
								case 0xa39e+23: fputc(0x07,out_fp); z=fgetc(org_fp); break;
								case 0xa39e+24: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xa39e+25: fputc(0x08,out_fp); z=fgetc(org_fp); break;
								case 0xa39e+28: fputc(0x10,out_fp); z=fgetc(org_fp); break;
								case 0xa39e+29: fputc(0x09,out_fp); z=fgetc(org_fp); break;

								case 0xa3bc+ 0: fputc(0xc8,out_fp); z=fgetc(org_fp); break;
								case 0xa3bc+ 1: fputc(0x07,out_fp); z=fgetc(org_fp); break;
								case 0xa3bc+ 4: fputc(0xca,out_fp); z=fgetc(org_fp); break;
								case 0xa3bc+ 5: fputc(0x07,out_fp); z=fgetc(org_fp); break;
								case 0xa3bc+ 6: fputc(0xcc,out_fp); z=fgetc(org_fp); break;
								case 0xa3bc+ 7: fputc(0x07,out_fp); z=fgetc(org_fp); break;
								case 0xa3bc+10: fputc(0xd4,out_fp); z=fgetc(org_fp); break;
								case 0xa3bc+11: fputc(0x07,out_fp); z=fgetc(org_fp); break;
								case 0xa3bc+12: fputc(0xd6,out_fp); z=fgetc(org_fp); break;
								case 0xa3bc+13: fputc(0x07,out_fp); z=fgetc(org_fp); break;
								case 0xa3bc+16: fputc(0xd8,out_fp); z=fgetc(org_fp); break;
								case 0xa3bc+17: fputc(0x07,out_fp); z=fgetc(org_fp); break;
								case 0xa3bc+18: fputc(0x90,out_fp); z=fgetc(org_fp); break;
								case 0xa3bc+19: fputc(0x06,out_fp); z=fgetc(org_fp); break;
								case 0xa3bc+22: fputc(0x30,out_fp); z=fgetc(org_fp); break;
								case 0xa3bc+23: fputc(0x07,out_fp); z=fgetc(org_fp); break;
								case 0xa3bc+24: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xa3bc+25: fputc(0x08,out_fp); z=fgetc(org_fp); break;
								case 0xa3bc+28: fputc(0x10,out_fp); z=fgetc(org_fp); break;
								case 0xa3bc+29: fputc(0x09,out_fp); z=fgetc(org_fp); break;

// [v
								case 0xa3e7: fputc(0x20,out_fp); z=fgetc(org_fp); break;

								case 0xa44a: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0xa44b: fputc(0x18,out_fp); z=fgetc(org_fp); break;
								case 0xa44c: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xa46d: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0xa46e: fputc(0x15,out_fp); z=fgetc(org_fp); break;
								case 0xa46f: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xa491: fputc(0x41,out_fp); z=fgetc(org_fp); break;
								case 0xa492: fputc(0x21,out_fp); z=fgetc(org_fp); break;
								case 0xa497: fputc(0x41,out_fp); z=fgetc(org_fp); break;
								case 0xa498: fputc(0x31,out_fp); z=fgetc(org_fp); break;
								case 0xa4a1: fputc(0xcd,out_fp); z=fgetc(org_fp); break;
								case 0xa4a2: fputc(0x12,out_fp); z=fgetc(org_fp); break;
								case 0xa4a3: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xa4a4: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0xa4aa: fputc(0xa0,out_fp); z=fgetc(org_fp); break;

								case 0xa4b3: fputc(0x41,out_fp); z=fgetc(org_fp); break;
								case 0xa4b4: fputc(0x21,out_fp); z=fgetc(org_fp); break;
								case 0xa4b8: fputc(0x8f,out_fp); z=fgetc(org_fp); break;
								case 0xa4bd: fputc(0x41,out_fp); z=fgetc(org_fp); break;
								case 0xa4be: fputc(0x31,out_fp); z=fgetc(org_fp); break;
								case 0xa4c2: fputc(0x50,out_fp); z=fgetc(org_fp); break;
								case 0xa4cb: fputc(0x00,out_fp); z=fgetc(org_fp); break;

// a\
								case 0xa9c7+0: fputc(0x00,out_fp); z=fgetc(org_fp); break;	// [v
								case 0xaa76+0: fputc(0x01,out_fp); z=fgetc(org_fp); break;
								case 0xaa84+0: fputc(0xcd,out_fp); z=fgetc(org_fp); break;
								case 0xaa84+1: fputc(0x12,out_fp); z=fgetc(org_fp); break;
								case 0xaa84+2: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xaa84+3: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0xaa84+4: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0xaa84+5: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0xaa90+0: fputc(0xa0,out_fp); z=fgetc(org_fp); break;

// a薼O
								case 0xaca8+0: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0xaca8+1: fputc(0x51,out_fp); z=fgetc(org_fp); break;
								case 0xaca8+2: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xacc8+0: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0xacc8+1: fputc(0x27,out_fp); z=fgetc(org_fp); break;
								case 0xacc8+2: fputc(0x70,out_fp); z=fgetc(org_fp); break;

// oߎԎ擾
								case 0xadbf: fputc(0xc9,out_fp); z=fgetc(org_fp); break;
								case 0xae0f: fputc(0xc9,out_fp); z=fgetc(org_fp); break;

// fUCi[pX[h
								case 0xaf28+0: fputc(0x39,out_fp); z=fgetc(org_fp); break;
								case 0xaf28+1: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xaf3b+0: fputc(0x39,out_fp); z=fgetc(org_fp); break;
								case 0xaf3b+1: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xaf43+0: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0xaf43+1: fputc(0xe6,out_fp); z=fgetc(org_fp); break;
								case 0xaf43+2: fputc(0xff,out_fp); z=fgetc(org_fp); break;
								case 0xaf80+0: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0xaf80+1: fputc(0x00,out_fp); z=fgetc(org_fp); break;

								case 0xafb1+ 0: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0xafb1+ 1: fputc(0x55,out_fp); z=fgetc(org_fp); break;
								case 0xafb1+ 2: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0xafb1+ 3: fputc(0x4e,out_fp); z=fgetc(org_fp); break;
								case 0xafb1+ 4: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0xafb1+ 5: fputc(0x4c,out_fp); z=fgetc(org_fp); break;
								case 0xafb1+ 6: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0xafb1+ 7: fputc(0x4f,out_fp); z=fgetc(org_fp); break;
								case 0xafb1+ 8: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0xafb1+ 9: fputc(0x43,out_fp); z=fgetc(org_fp); break;
								case 0xafb1+10: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0xafb1+11: fputc(0x4b,out_fp); z=fgetc(org_fp); break;

// fUCi[ʐݒ
								case 0xb617+ 0: fputc(0xdf,out_fp); z=fgetc(org_fp); break;

								case 0xb62a+ 0: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0xb62a+ 1: fputc(0x3c,out_fp); z=fgetc(org_fp); break;
								case 0xb62a+ 2: fputc(0x70,out_fp); z=fgetc(org_fp); break;

								case 0xb7a4+ 0: fputc(0x52,out_fp); z=fgetc(org_fp); break;
								case 0xb7a4+ 1: fputc(0x0d,out_fp); z=fgetc(org_fp); break;
								case 0xb7a7+ 0: fputc(0xcd,out_fp); z=fgetc(org_fp); break;
								case 0xb7a7+ 1: fputc(0x48,out_fp); z=fgetc(org_fp); break;
								case 0xb7a7+ 2: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xb7a7+ 3: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0xb7b5+ 0: fputc(0x3a,out_fp); z=fgetc(org_fp); break;
								case 0xb7b5+ 1: fputc(0x0d,out_fp); z=fgetc(org_fp); break;
								case 0xb7bc+ 0: fputc(0x10,out_fp); z=fgetc(org_fp); break;
								case 0xb7c6+ 0: fputc(0x1a,out_fp); z=fgetc(org_fp); break;
								case 0xb7d7+ 0: fputc(0x06,out_fp); z=fgetc(org_fp); break;
								case 0xb7da+ 0: fputc(0xcf,out_fp); z=fgetc(org_fp); break;
								case 0xb7da+ 1: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0xb7dd+ 0: fputc(0x10,out_fp); z=fgetc(org_fp); break;

								case 0xb9d4+ 0: fputc(0xe0,out_fp); z=fgetc(org_fp); break;
								case 0xb9d4+ 1: fputc(0x0b,out_fp); z=fgetc(org_fp); break;
								case 0xb9df+ 0: fputc(0x20,out_fp); z=fgetc(org_fp); break;
								case 0xb9df+ 1: fputc(0x0d,out_fp); z=fgetc(org_fp); break;

								case 0xbafd+ 0: fputc(0x80,out_fp); z=fgetc(org_fp); break;
								case 0xbafd+ 1: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xbb07+ 0: fputc(0x92,out_fp); z=fgetc(org_fp); break;
								case 0xbb07+ 1: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xbb0e+ 0: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0xbb0e+ 1: fputc(0x54,out_fp); z=fgetc(org_fp); break;
								case 0xbb0e+ 2: fputc(0x70,out_fp); z=fgetc(org_fp); break;

								case 0xbb2a+ 0: fputc(0xcd,out_fp); z=fgetc(org_fp); break;
								case 0xbb2a+ 1: fputc(0x42,out_fp); z=fgetc(org_fp); break;
								case 0xbb2a+ 2: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xbb2a+ 3: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0xbb2a+ 4: fputc(0x00,out_fp); z=fgetc(org_fp); break;
								case 0xbb2a+ 5: fputc(0x20,out_fp); z=fgetc(org_fp); break;

								case 0xbba3+ 0: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0xbba3+ 1: fputc(0x45,out_fp); z=fgetc(org_fp); break;
								case 0xbba3+ 2: fputc(0x70,out_fp); z=fgetc(org_fp); break;

								case 0xbbd0+ 0: fputc(0xcd,out_fp); z=fgetc(org_fp); break;
								case 0xbbd0+ 1: fputc(0x42,out_fp); z=fgetc(org_fp); break;
								case 0xbbd0+ 2: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xbbd0+ 3: fputc(0x00,out_fp); z=fgetc(org_fp); break;

								case 0xbbea+ 0: fputc(0xcd,out_fp); z=fgetc(org_fp); break;
								case 0xbbea+ 1: fputc(0x42,out_fp); z=fgetc(org_fp); break;
								case 0xbbea+ 2: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xbbea+ 3: fputc(0x00,out_fp); z=fgetc(org_fp); break;

								case 0xbc0d+ 0: fputc(0xcd,out_fp); z=fgetc(org_fp); break;
								case 0xbc0d+ 1: fputc(0x42,out_fp); z=fgetc(org_fp); break;
								case 0xbc0d+ 2: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xbc0d+ 3: fputc(0x00,out_fp); z=fgetc(org_fp); break;

								case 0xbc1f+ 0: fputc(0xcd,out_fp); z=fgetc(org_fp); break;
								case 0xbc1f+ 1: fputc(0x42,out_fp); z=fgetc(org_fp); break;
								case 0xbc1f+ 2: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xbc1f+ 3: fputc(0x00,out_fp); z=fgetc(org_fp); break;

								case 0xbc2d+ 0: fputc(0x3a,out_fp); z=fgetc(org_fp); break;
								case 0xbc2d+ 1: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xbc2d+ 2: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xbc2d+ 3: fputc(0xd6,out_fp); z=fgetc(org_fp); break;
								case 0xbc2d+ 4: fputc(0x30,out_fp); z=fgetc(org_fp); break;
								case 0xbc2d+ 5: fputc(0x20,out_fp); z=fgetc(org_fp); break;
								case 0xbc2d+ 6: fputc(0x08,out_fp); z=fgetc(org_fp); break;
								case 0xbc3b+ 0: fputc(0xc9,out_fp); z=fgetc(org_fp); break;
								case 0xbc3c+ 0: fputc(0xd8,out_fp); z=fgetc(org_fp); break;
								case 0xbc3c+ 1: fputc(0xfe,out_fp); z=fgetc(org_fp); break;
								case 0xbc3c+ 2: fputc(0x09,out_fp); z=fgetc(org_fp); break;
								case 0xbc3c+ 3: fputc(0xd0,out_fp); z=fgetc(org_fp); break;
								case 0xbc3c+ 4: fputc(0x4f,out_fp); z=fgetc(org_fp); break;
								case 0xbc3c+ 5: fputc(0x18,out_fp); z=fgetc(org_fp); break;
								case 0xbc3c+ 6: fputc(0x0d,out_fp); z=fgetc(org_fp); break;

								case 0xbc63+ 0: fputc(0xc3,out_fp); z=fgetc(org_fp); break;
								case 0xbc63+ 1: fputc(0x4e,out_fp); z=fgetc(org_fp); break;
								case 0xbc63+ 2: fputc(0x70,out_fp); z=fgetc(org_fp); break;

								case 0xbd34+ 0: fputc(0x3a,out_fp); z=fgetc(org_fp); break;
								case 0xbd34+ 1: fputc(0x2c,out_fp); z=fgetc(org_fp); break;
								case 0xbd3b+ 0: fputc(0x3a,out_fp); z=fgetc(org_fp); break;
								case 0xbd3b+ 1: fputc(0x3c,out_fp); z=fgetc(org_fp); break;

								case 0xbdb0+ 0: fputc(0xef,out_fp); z=fgetc(org_fp); break;

								case 0xbdfe+ 0: fputc(0xff,out_fp); z=fgetc(org_fp); break;
								case 0xbdfe+ 1: fputc(0xff,out_fp); z=fgetc(org_fp); break;
								case 0xbdfe+ 2: fputc(0xff,out_fp); z=fgetc(org_fp); break;
								case 0xbdfe+ 3: fputc(0xff,out_fp); z=fgetc(org_fp); break;
								case 0xbdfe+ 4: fputc(0xff,out_fp); z=fgetc(org_fp); break;
								case 0xbdfe+ 5: fputc(0xff,out_fp); z=fgetc(org_fp); break;
								case 0xbdfe+ 6: fputc(0xff,out_fp); z=fgetc(org_fp); break;
								case 0xbdfe+ 7: fputc(0xff,out_fp); z=fgetc(org_fp); break;

								case 0xbf47+ 0: fputc(0x3f,out_fp); z=fgetc(org_fp); break;
								case 0xbf47+ 1: fputc(0x70,out_fp); z=fgetc(org_fp); break;
								case 0xbf50+ 0: fputc(0x4b,out_fp); z=fgetc(org_fp); break;
								case 0xbf50+ 1: fputc(0x70,out_fp); z=fgetc(org_fp); break;

								default:
									z = fgetc(org_fp);

									if (0xc200 <= m && m < 0xd000) {
										men_org[(m-0xc200)] = z;
									}
									if (0xaae8 <= m && m < 0xab42) {
										hi_org[(m-0xaae8)] = z;
									}

									fputc(z,out_fp);
									break;
							}
						}
					}
					break;

				case 8:
				case 9:
				case 10:
				case 11:
				case 12:
				case 13:
				case 14:
				case 15:
				case 16:
				case 17:
/* track#8 - #17 */
					for (j=0; j<256; j++ ) {
						if (i < 2) {
							if (j < 90) {
								if (k == 8) {
									fputc(hi_org[j],out_fp);
								} else {
									fputc(hiscore[j],out_fp);
								}
							} else {
								fputc(0x00,out_fp);
							}
						} else {
							if        (k ==  8) {
								fputc(men_org[(i-2)*256+j],out_fp);	// track#8  sec#3-#16 -> DATA_org
							} else if (k ==  9) {
								fputc(fgetc(data1_fp),out_fp);	// track#9  sec#3-#16 -> DATA1
							} else if (k == 10) {
								fputc(fgetc(data2_fp),out_fp);	// track#10 sec#3-#16 -> DATA2
							} else if (k == 11) {
								fputc(fgetc(data3_fp),out_fp);	// track#11 sec#3-#16 -> DATA3
							} else if (k == 12) {
								fputc(fgetc(data4_fp),out_fp);	// track#12 sec#3-#16 -> DATA4
							} else if (k == 13) {
								fputc(fgetc(data5_fp),out_fp);	// track#13 sec#3-#16 -> DATA5
							} else if (k == 14) {
								fputc(fgetc(data6_fp),out_fp);	// track#14 sec#3-#16 -> DATA6
							} else if (k == 15) {
								fputc(fgetc(data7_fp),out_fp);	// track#15 sec#3-#16 -> DATA7
							} else if (k == 16) {
								fputc(fgetc(data8_fp),out_fp);	// track#16 sec#3-#16 -> DATA8
							} else if (k == 17) {
								fputc(fgetc(data9_fp),out_fp);	// track#17 sec#3-#16 -> DATA9
							}
						}
					}
					break;

				default:
					for (j=0; j<256; j++ ) {
						fputc(0x00,out_fp);
					}
					break;
			}

		}
	}


	fclose(ipl1_fp);
	fclose(ipl2_fp);
	fclose(prog_fp);
	fclose(org_fp);
	fclose(data1_fp);
	fclose(data2_fp);
	fclose(data3_fp);
	fclose(data4_fp);
	fclose(data5_fp);
	fclose(data6_fp);
	fclose(data7_fp);
	fclose(data8_fp);
	fclose(data9_fp);
	fclose(out_fp);

	return(0);
}
